#include "owl.h"
#include <string.h>
#include <unistd.h>

void owl_typwin_init(owl_typwin *t) {
  strcpy(t->buff, "");
  t->bufflen=0;
  t->topline=0;
}

void owl_typwin_addchr(owl_typwin *t, int c) {
  t->buff[t->bufflen]=c;
  t->buff[t->bufflen+1]='\0';
  t->bufflen++;
}

void owl_typwin_delchr(owl_typwin *t) {
  if (t->bufflen>0) {
    t->buff[t->bufflen-1]='\0';
    t->bufflen--;
  }
}

void owl_typwin_clear(owl_typwin *t) {
  owl_typwin_init(t);
}

char *owl_typwin_get_buff(owl_typwin *t) {
  return(t->buff);
}

void owl_typwin_getmore(owl_typwin *t) {
  WINDOW *typwin;
  int j, x, y;

  typwin=owl_global_get_curs_typwin(&g);

  while (1) {
    usleep(10);
    
    j=wgetch(typwin);

    if (j == ERR) continue;

    if (j == KEY_UP) {
      getyx(typwin, y, x);
      if (y>0) {
	wmove(typwin, y-1, x);
      } else {
	if (t->topline>0) {
	  t->topline--;
	  owl_typwin_redisplay(t);
	  wmove(typwin, y, x);
	}
      }
      continue;
    } else if (j == KEY_DOWN) {
      getyx(typwin, y, x);
      if (y+1<owl_global_get_typwin_lines(&g)) {
	wmove(typwin, y+1, x);
      } else {
	if (y<owl_text_num_lines(t->buff)-2) {
	  t->topline++;
	  owl_typwin_redisplay(t);
	}
      }
      continue;
    }

    if (j == 8 || j == 127) {
      getyx(typwin, y, x);
      if (x>0) {
	wmove(typwin, y, x-1);
	waddch(typwin, ' ');
	wmove(typwin, y, x-1);
	wrefresh(typwin);
	owl_typwin_delchr(t);
      } else {
	/* back up to the previous line if we can */
      }
      continue;
    }

    /* this won't work for now */
    if (j==3) {
      owl_typwin_clear(t);
      return;
    }
    
    if (j>127 || ((j<32) && (j!=10) && (j!=13))) continue;

    waddch(typwin, j);
    owl_typwin_addchr(t, j);

    if (j==10 || j==13) {
      getyx(typwin, y, x);
      if (y+2 > owl_global_get_typwin_lines(&g)) {
	t->topline++;
	owl_typwin_redisplay(t);
      }
    }
  }

}

void owl_typwin_redisplay(owl_typwin *t) {
  WINDOW *typwin;
  char *ptr, *ptr2;
  int i;

  typwin=owl_global_get_curs_typwin(&g);

  ptr=t->buff;
  for (i=0; i<t->topline; i++) {
    ptr2=strchr(ptr, '\n');
    if (!ptr2) break;
    ptr=ptr2+1;
  }

  werase(typwin);
  waddstr(typwin, ptr);
  wrefresh(typwin);
}
